package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface StorageGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.StorageGWTService
     */
    void findStorageNodesByCriteria( org.rhq.core.domain.criteria.StorageNodeCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.cloud.StorageNode>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.StorageGWTService
     */
    void invokeOperationOnStorageService( int storageNodeId, java.lang.String operationName, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.StorageGWTService
     */
    void getLoad( org.rhq.core.domain.cloud.StorageNode node, int lastN, int unit, AsyncCallback<org.rhq.core.domain.cloud.StorageNodeLoadComposite> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static StorageGWTServiceAsync instance;

        public static final StorageGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (StorageGWTServiceAsync) GWT.create( StorageGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "StorageGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
