package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface SystemGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getProductInfo( AsyncCallback<org.rhq.core.domain.common.ProductInfo> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getServerDetails( AsyncCallback<org.rhq.core.domain.common.ServerDetails> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getSessionTimeout( AsyncCallback<java.lang.String> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getSystemSettings( AsyncCallback<org.rhq.core.domain.common.composite.SystemSettings> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void setSystemSettings( org.rhq.core.domain.common.composite.SystemSettings settings, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getAgentVersionProperties( AsyncCallback<java.util.HashMap<java.lang.String,java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getConnectorDownloads( AsyncCallback<java.util.HashMap<java.lang.String,java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getCliAlertScriptDownloads( AsyncCallback<java.util.HashMap<java.lang.String,java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getScriptModulesDownloads( AsyncCallback<java.util.HashMap<java.lang.String,java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getClientVersionProperties( AsyncCallback<java.util.HashMap<java.lang.String,java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void getBundleDeployerDownload( AsyncCallback<java.util.HashMap<java.lang.String,java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void isLdapAuthorizationEnabled( AsyncCallback<java.lang.Boolean> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService
     */
    void dumpToLog( AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static SystemGWTServiceAsync instance;

        public static final SystemGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (SystemGWTServiceAsync) GWT.create( SystemGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "SystemGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
